/*******************************************************************************
* Copyright (C) 2016 Maxim Integrated Products, Inc., All rights Reserved.
* 
* This software is protected by copyright laws of the United States and
* of foreign countries. This material may also be protected by patent laws
* and technology transfer regulations of the United States and of foreign
* countries. This software is furnished under a license agreement and/or a
* nondisclosure agreement and may only be used or reproduced in accordance
* with the terms of those agreements. Dissemination of this information to
* any party or parties not specified in the license agreement and/or
* nondisclosure agreement is expressly prohibited.
*
* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
* IN NO EVENT SHALL MAXIM INTEGRATED BE LIABLE FOR ANY CLAIM, DAMAGES
* OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
* ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
* OTHER DEALINGS IN THE SOFTWARE.
*
* Except as contained in this notice, the name of Maxim Integrated
* Products, Inc. shall not be used except as stated in the Maxim Integrated
* Products, Inc. Branding Policy.
*
* The mere transfer of this software does not imply any licenses
* of trade secrets, proprietary technology, copyrights, patents,
* trademarks, maskwork rights, or any other form of intellectual
* property whatsoever. Maxim Integrated Products, Inc. retains all
* ownership rights.
*******************************************************************************
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using NUnit.Framework;
using HealthSensorPlatform.CustomControls;

namespace EcgViewTest
{
    class TemperatureTest
    {
        [TestCase(0x7fff, 128)]
        [TestCase(0x7f00, 127)]
        [TestCase(0x7d00, 125)]
        [TestCase(0x4000, 64)]
        [TestCase(0x1900, 25)]
        [TestCase(0x0080, 0.5)]
        [TestCase(0x0000, 0)]
        [TestCase(0xff80, -0.5)]
        [TestCase(0xe700, -25)]
        [TestCase(0xc900, -55)]
        public void TemperatureNormalFormat(int hex, double temperature)
        {
            TemperatureView view = new TemperatureView();

            Assert.AreEqual(temperature, view.HexToTemperature(hex, false), 0.01);
        }

        [TestCase(0x5600, 150)]
        [TestCase(0x4000, 128)]
        [TestCase(0x3f00, 127)]
        [TestCase(0x3d00, 125)]
        [TestCase(0x0000, 64)]
        [TestCase(0xD900, 25)]
        [TestCase(0xC080, 0.5)]
        [TestCase(0xC000, 0)]
        [TestCase(0xBF80, -0.5)]
        [TestCase(0xA700, -25)]
        [TestCase(0x8900, -55)]
        public void TemperatureExtendedFormat(int hex, double temperature)
        {
            TemperatureView view = new TemperatureView();

            Assert.AreEqual(temperature, view.HexToTemperature(hex, true), 0.01);
        }
    }
}
